| Flutter Linux Embedder |

Functions
fl_pixel_buffer_texture_private.h File Reference
`#include "flutter/shell/platform/embedder/embedder.h"`
`#include "flutter/shell/platform/linux/public/flutter_linux/fl_pixel_buffer_texture.h"`
`#include "flutter/shell/platform/linux/public/flutter_linux/fl_texture_registrar.h"`

Go to the source code of this file.

## Functions
G_BEGIN_DECLS gboolean | fl_pixel_buffer_texture_populate (FlPixelBufferTexture *texture, uint32_t width, uint32_t height, FlutterOpenGLTexture *opengl_texture, GError **error)

## Function Documentation

## ◆ fl_pixel_buffer_texture_populate()

G_BEGIN_DECLS gboolean fl_pixel_buffer_texture_populate | ( | FlPixelBufferTexture * | texture,
|  | uint32_t | width,
|  | uint32_t | height,
|  | FlutterOpenGLTexture * | opengl_texture,
|  | GError ** | error
| ) |  |

fl_pixel_buffer_texture_populate: @texture: an #FlPixelBufferTexture. @width: width of the texture. @height: height of the texture. @opengl_texture: (out): return an #FlutterOpenGLTexture. @error: (allow-none): #GError location to store the error occurring, or NULL to ignore. If `error` is not NULL, `*error` must be initialized (typically NULL, but an error from a previous call using GLib error handling is explicitly valid).

Attempts to populate the specified @opengl_texture with texture details such as the name, width, height and the pixel format.

Returns: TRUE on success.

Definition at line 71 of file fl_pixel_buffer_texture.cc.

75 {
76 FlPixelBufferTexture* self = FL_PIXEL_BUFFER_TEXTURE(texture);
77 FlPixelBufferTexturePrivate* priv =
78 reinterpret_cast<FlPixelBufferTexturePrivate*>(
79 fl_pixel_buffer_texture_get_instance_private(self));
80
81 const uint8_t* buffer = nullptr;
82 if (!FL_PIXEL_BUFFER_TEXTURE_GET_CLASS(self)->copy_pixels(
83 self, &buffer, &width, &height, error)) {
84 return FALSE;
85 }
86
87 if (priv->texture_id == 0) {
88 glGenTextures(1, &priv->texture_id);
89 check_gl_error(__LINE__);
90 glBindTexture(GL_TEXTURE_2D, priv->texture_id);
91 check_gl_error(__LINE__);
92 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_BORDER);
93 check_gl_error(__LINE__);
94 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_BORDER);
95 check_gl_error(__LINE__);
96 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
97 check_gl_error(__LINE__);
98 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
99 check_gl_error(__LINE__);
100 } else {
101 glBindTexture(GL_TEXTURE_2D, priv->texture_id);
102 check_gl_error(__LINE__);
103 }
104 glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, width, height, 0, GL_RGBA,
105 GL_UNSIGNED_BYTE, buffer);
106 check_gl_error(__LINE__);
107
108 opengl_texture->target = GL_TEXTURE_2D;
109 opengl_texture->name = priv->texture_id;
110 opengl_texture->format = GL_RGBA8;
111 opengl_texture->destruction_callback = nullptr;
112 opengl_texture->user_data = nullptr;
113 opengl_texture->width = width;
114 opengl_texture->height = height;
115
116 return TRUE;
117 }
height
self height
Definition: fl_compositor_software.cc:43
width
self width
Definition: fl_compositor_software.cc:42
TRUE
return TRUE
Definition: fl_compositor_software.cc:68
check_gl_error
static void check_gl_error(int line)
Definition: fl_pixel_buffer_texture.cc:64
priv
FlPixelBufferTexturePrivate * priv
Definition: fl_pixel_buffer_texture.cc:30
buffer
static const uint8_t buffer[]
Definition: fl_pixel_buffer_texture_test.cc:44
error
const uint8_t uint32_t uint32_t GError ** error
Definition: fl_pixel_buffer_texture_test.cc:40
FlPixelBufferTexturePrivate
Definition: fl_pixel_buffer_texture.cc:12
FlPixelBufferTexturePrivate::texture_id
GLuint texture_id
Definition: fl_pixel_buffer_texture.cc:14

References buffer, check_gl_error(), error, height, priv, FlPixelBufferTexturePrivate::texture_id, TRUE, and width.

Referenced by fl_engine_gl_external_texture_frame_callback(), and TEST().